#include "mqtt.hpp"
#include "settings.hpp"

#include <WiFiClient.h>

WiFiClient wifiClient;

MQTT::MQTT(Settings *settings, MQTT_CALLBACK_SIGNATURE)
{
    IPAddress ip;
    if (!ip.fromString(settings->gettext("mqtt:hostname")))
        return;

    this->settings = settings;
    this->client = new PubSubClient(ip, 1883, callback, wifiClient);
}

void MQTT::connect()
{
    this->client->connect(this->settings->gettext("mqtt:ident"), this->settings->gettext("mqtt:username"), this->settings->gettext("mqtt:password"));
    this->client->unsubscribe(this->settings->gettext("mqtt:state_topic"));
    this->client->subscribe(this->settings->gettext("mqtt:state_topic"));
}

void MQTT::send(String payload)
{
    client->publish(this->settings->gettext("mqtt:command_topic"), payload.c_str());
}

void MQTT::loop()
{
    if (client != nullptr)
    {
        if (!client->connected())
        {
            client->connect(this->settings->gettext("mqtt:ident"), this->settings->gettext("mqtt:username"), this->settings->gettext("mqtt:password"));
        }
        client->loop();
    }
}
