#include "settings.hpp"
#include <SD.h>

Settings::Settings()
{
    Serial.println("Loading settings");
    if (!SD.exists("/settings.yml"))
    {
        Serial.println("settings.yml not found");
        return;
    }

    File settingsFile = SD.open("/settings.yml");
    this->yaml = YAMLNode::loadStream(settingsFile);
    settingsFile.close();
}

const char *Settings::gettext(const char *path, char delimiter)
{
    return this->yaml.gettext(path, delimiter);
}
