#include <utility/GT911.h>
#ifndef _TOUCH_H_
#define _TOUCH_H_

#include <optional>

class Touch
{
public:
    Touch(GT911 TP) : TP{TP} {}

    std::optional<tp_finger_t> tap()
    {
        if (!TP.available())
        {
            return std::nullopt;
        }

        TP.update();

        if (TP.isFingerUp())
        {
            touching = false;
            return std::nullopt;
        }

        if (touching)
        {
            return std::nullopt;
        }

        touching = true;
        return TP.readFinger(0);
    }

private:
    GT911 TP;
    tp_finger_t finger;
    bool touching;
};

#endif